=== lib/compat/CMakeLists.txt ===
set(COMPAT_HEADERS
    compat/compat.h
    compat/getutent.h
    compat/glib.h
    compat/lfs.h
    compat/pio.h
    compat/socket.h
    compat/string.h
    compat/time.h
    compat/openssl_support.h
    compat/pcre.h
    compat/getent.h
    compat/getent-sun.h
    compat/getent-openbsd.h
    compat/getent-generic.h
    compat/un.h
    compat/cpp-start.h
    compat/cpp-end.h
    compat/curl.h
    compat/json.h
    PARENT_SCOPE)

set(COMPAT_SOURCES
    compat/getutent.c
    compat/glib.c
    compat/inet_aton.c
    compat/memrchr.c
    compat/pio.c
    compat/strcasestr.c
    compat/strtok_r.c
    compat/strnlen.c
    compat/getline.c
    compat/time.c
    compat/openssl_support.c
    compat/getent-sun.c
    compat/getent-openbsd.c
    compat/getent-generic.c
    PARENT_SCOPE)

add_test_subdirectory(tests)
