=== lib/filterx/CMakeLists.txt ===
set(FILTERX_HEADERS
    filterx/expr-assign.h
    filterx/expr-boolalg.h
    filterx/expr-comparison.h
    filterx/expr-function.h
    filterx/expr-getattr.h
    filterx/expr-get-subscript.h
    filterx/expr-dict.h
    filterx/expr-list.h
    filterx/expr-literal.h
    filterx/expr-message-ref.h
    filterx/expr-setattr.h
    filterx/expr-set-subscript.h
    filterx/expr-template.h
    filterx/filterx-config.h
    filterx/filterx-eval.h
    filterx/filterx-expr.h
    filterx/filterx-globals.h
    filterx/filterx-object.h
    filterx/filterx-parser.h
    filterx/filterx-pipe.h
    filterx/filterx-scope.h
    filterx/filterx-weakrefs.h
    filterx/object-datetime.h
    filterx/object-json.h
    filterx/object-json-internal.h
    filterx/object-message-value.h
    filterx/object-null.h
    filterx/object-primitive.h
    filterx/object-string.h
    filterx/object-list-interface.h
    filterx/object-dict-interface.h
    filterx/expr-condition.h
    filterx/expr-isset.h
    filterx/expr-unset.h
    filterx/filterx-private.h
    PARENT_SCOPE
    )

set(FILTERX_SOURCES
    filterx/expr-assign.c
    filterx/expr-boolalg.c
    filterx/expr-comparison.c
    filterx/expr-function.c
    filterx/expr-getattr.c
    filterx/expr-get-subscript.c
    filterx/expr-dict.c
    filterx/expr-list.c
    filterx/expr-literal.c
    filterx/expr-message-ref.c
    filterx/expr-setattr.c
    filterx/expr-set-subscript.c
    filterx/expr-template.c
    filterx/filterx-config.c
    filterx/filterx-eval.c
    filterx/filterx-expr.c
    filterx/filterx-globals.c
    filterx/filterx-object.c
    filterx/filterx-parser.c
    filterx/filterx-pipe.c
    filterx/filterx-scope.c
    filterx/filterx-weakrefs.c
    filterx/object-datetime.c
    filterx/object-json.c
    filterx/object-json-object.c
    filterx/object-json-array.c
    filterx/object-message-value.c
    filterx/object-null.c
    filterx/object-primitive.c
    filterx/object-string.c
    filterx/object-list-interface.c
    filterx/object-dict-interface.c
    filterx/expr-condition.c
    filterx/expr-isset.c
    filterx/expr-unset.c
    filterx/filterx-private.c
    PARENT_SCOPE
    )

add_test_subdirectory(tests)
